VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "The Naked RichEdit Control"
   ClientHeight    =   4260
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   6345
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4260
   ScaleWidth      =   6345
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'General Function Declarations
Private Declare Function CreateWindowEx Lib "user32" _
    Alias "CreateWindowExA" ( _
    ByVal dwExStyle As Long, _
    ByVal lpClassName As Long, _
    ByVal lpWindowName As Long, _
    ByVal dwStyle As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hWndParent As Long, _
    ByVal hMenu As Long, _
    ByVal hInstance As Long, _
    ByVal lpParam As Long) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetFocusAPI Lib "user32" Alias "SetFocus" (ByVal hWnd As Long) As Long
Private Declare Function GetCurrentObject Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal uObjectType As Long) As Long
Private Declare Function LoadLibrary Lib "kernel32" _
    Alias "LoadLibraryW" ( _
    ByVal lpLibFileName As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hModule As Long) As Long
Private Declare Function SendMessage Lib "user32" _
    Alias "SendMessageA" ( _
    ByVal hWnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long
Private Declare Function SetWindowPos Lib "user32" _
   (ByVal hWnd As Long, _
    ByVal hWndInsAfter As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long

'General Variable Declarations
Private Const OBJ_FONT As Long = 6

Private Const WM_SETFONT As Long = &H30
Private Const WM_USER As Long = &H400
Private Const EM_SETMARGINS As Long = &HD3&
Private Const EM_STREAMIN As Long = WM_USER + 73
Private Const EM_SETTEXTMODE As Long = WM_USER + 89
Private Const EM_SETTEXTEX As Long = WM_USER + 97

Private Const SF_RTF As Long = 2

Private Const EC_LEFTMARGIN As Long = &H1&
Private Const EC_RIGHTMARGIN As Long = &H2&

Private Const ES_MULTILINE As Long = &H4
Private Const ES_READONLY As Long = &H800&
Private Const ES_WANTRETURN As Long = &H1000&

Private Const WS_CHILD As Long = &H40000000
Private Const WS_EX_CLIENTEDGE As Long = &H200&
Private Const WS_VISIBLE As Long = &H10000000
Private Const WS_VSCROLL As Long = &H200000

Private Const SWP_NOZORDER As Long = &H4&

Private Type EDITSTREAM
    dwCookie As Long
    dwError As Long
    pfnCallback As Long
End Type

Private hRichEd20 As Long
Private hWndRichEd As Long

Private Function FunctionPtr(ByVal UseAddressOf As Long) As Long
    FunctionPtr = UseAddressOf
End Function

Private Sub Form_Load()
    Dim hFont As Long
    Dim EDITSTREAM As EDITSTREAM
    
    'Load the Rich Edit library.
    hRichEd20 = LoadLibrary(StrPtr("riched20.dll"))

    'Create the control.
    hWndRichEd = CreateWindowEx(WS_EX_CLIENTEDGE, _
                                StrPtr(StrConv("RichEdit20A", vbFromUnicode)), 0, _
                                ES_MULTILINE Or ES_WANTRETURN Or WS_CHILD Or WS_VISIBLE _
                                Or WS_VSCROLL Or ES_READONLY, _
                                0, 0, _
                                ScaleX(ScaleWidth, vbTwips, vbPixels), _
                                ScaleY(ScaleHeight, vbTwips, vbPixels), _
                                hWnd, 0, App.hInstance, 0)

    'Set the control to use the form's font
    hFont = GetCurrentObject(hDC, OBJ_FONT)
    SendMessage hWndRichEd, WM_SETFONT, hFont, 1
    'Set margins.
    SendMessage hWndRichEd, EM_SETMARGINS, EC_LEFTMARGIN Or EC_RIGHTMARGIN, _
                10 Or 10 * &H10000
    SetFocusAPI hWndRichEd
    
    EDITSTREAM.pfnCallback = FunctionPtr(AddressOf Form1Calbacks.EditStreamCallback)
    SendMessage hWndRichEd, EM_STREAMIN, SF_RTF, VarPtr(EDITSTREAM)
End Sub

Private Sub Form_Resize()
    SetWindowPos hWndRichEd, 0, 0, 0, _
                 ScaleX(ScaleWidth, ScaleMode, vbPixels), _
                 ScaleY(ScaleHeight, ScaleMode, vbPixels), _
                 SWP_NOZORDER
End Sub

Private Sub Form_Unload(Cancel As Integer)
    DestroyWindow hWndRichEd
    FreeLibrary hRichEd20
End Sub
